/** Actor.cpp
 *
 * See the header file for details.
 */

#include "Actor.h"

#include "Functions.hpp"
#include "Text.hpp"

Actor::Actor() {
	setAffectedByGravity(true);
}
	
Actor::~Actor() {
}

bool Actor::update(bool onGround) {
	return true;
}

void Actor::draw() {
	raylib::Text message("Override Actor::draw()", 20, RED, ::GetFontDefault(), 1.0f);
	auto textSize = message.MeasureEx();
	message.Draw(position, 0, textSize / 2);
}

raylib::Rectangle Actor::getBoundingBox() {
	return raylib::Rectangle(position.x, position.y);
}

void Actor::setAffectedByGravity(bool affectedByGravity) {
	this->affectedByGravity = affectedByGravity;
}

bool Actor::isAffectedByGravity() const {
	return affectedByGravity;
}
