/** ScarfyScene.cpp
 *
 * See header file for details.
 */

#include "ScarfyScene.h"

#include "TrackingCamera2D.h"
#include "Common.h"

ScarfyScene::ScarfyScene() {
}
	
ScarfyScene::~ScarfyScene() {
}
	
void ScarfyScene::loadResources() {
	int screenWidth = GetScreenWidth();
	int screenHeight = GetScreenHeight();
	auto sceneSize = get2DSize();
	raylib::Vector2 cameraOffset(screenWidth/2, screenHeight/2);
	raylib::Vector2 cameraTarget(screenWidth/2, 1765+sceneSize.y - screenHeight/2); 
	groundYPos = cameraTarget.y + screenHeight / 4;
	
	tileMap = std::make_shared<TileMap2D>(DATADIR "Level 1.tmj");
	std::shared_ptr<Scarfy> scarfy = std::make_shared<Scarfy>();
	
	int sceneWidth = GetScreenWidth();
	scarfy->position = raylib::Vector2(sceneWidth / 2, groundYPos);
	
	playerAvatar = scarfy;
	actors.emplace_back(scarfy);
	
	auto camera = std::make_shared<TrackingCamera2D>(cameraOffset, cameraTarget);
	setCamera(camera);
	camera->setTarget(scarfy);
}
