/** TileMap2DScene.h
 *
 * Base class for 2D scenes with tilemaps.
 *
 * @author Hans de Ruiter
 *
 * @copyright (c) 2022 by Kea Sigma Delta Limited, all rights reserved
 *
 * See License.txt for license.
 */

#pragma once

#include "Scene.h"
#include "TileMap2D.h"

class TileMap2D;

class TileMap2DScene : public Scene {
public:
	TileMap2DScene();
	
	/** Loads the tile-map from file.
	 */
	TileMap2DScene(const std::string &fileName);
	
	virtual ~TileMap2DScene();
	
	virtual raylib::Vector2 get2DSize() const;
	
	virtual std::shared_ptr<Scene> update();
	
	virtual void draw();
	
protected:
	/** The tile-map.
	 * Child-classes should set this
	 */
	std::shared_ptr<TileMap2D> tileMap;
};
